function data_surface = gsw_linear_interp_data_surface(data,p,p_surface)

% gsw_linear_interp_data_surface
%==========================================================================
%
% USAGE:
%  data_surface = gsw_linear_interp_data_surface(data,p,p_surface)
%
% DESCRIPTION:
%  This function linear interpolates data onto a surface.
%
% INPUT:
%
% OUTPUT:
%
% AUTHOR:
%  Paul Barker                     [ help@teos-10.org ]
%
% VERSION NUMBER: 3.06.4 (27th July, 2018)
%
%  The software is available from http://www.TEOS-10.org
%
%==========================================================================

sz_data = size(data);
dims_data = length(sz_data);
data_surface = NaN(size(p_surface));

if dims_data == 2
    
    for Iprofiles = 1:sz_data(2)
        data_surface(:,Iprofiles) = gsw_linear_interp(data(:,Iprofiles),p(:,Iprofiles),p_surface(:,Iprofiles));
    end
    
elseif dims_data == 3
    
    for Iprofiles1 = 1:sz_data(2)
        for Iprofiles2 = 1:sz_data(3)
            data_surface(:,Iprofiles1,Iprofiles2) = gsw_linear_interp(data(:,Iprofiles1,Iprofiles2),p(:,Iprofiles1,Iprofiles2),p_surface(:,Iprofiles1,Iprofiles2));
        end
    end
    
end

end