load C:\Users\Paul\Documents\MATLAB\gsw_ns2d\test_data\test_gk_gsw_ak_gamma.mat 

%--------------------------------------------------------------------------
% Interpolate the data using TEOS-10 variables. Note that there can not be
% any gaps within a cast.
SA_out = nan(size(SA));
CT_out = SA_out;
p1d = p(:,1,1);

for I1 = 1:171
    for I2 = 1:360
        data_dummy = squeeze(SA(:,I1,I2)) + squeeze(CT(:,I1,I2)) + squeeze(p(:,I1,I2));
        [Idata_dummy] = find(~isnan(data_dummy));
        if length(Idata_dummy) > 1
            [SA_out(:,I1,I2),CT_out(:,I1,I2)] = gsw_SA_CT_interp(squeeze(SA(Idata_dummy,I1,I2)),squeeze(CT(Idata_dummy,I1,I2)),squeeze(p(Idata_dummy,I1,I2)),p1d);
        end
    end
end

SA_old = SA;
CT_old = CT;

SA = SA_out;
CT = CT_out;
clear SA_out CT_out
%--------------------------------------------------------------------------


%--------------------------------------------------------------------------
% The average value of the sigma2 surface is retained throughout the
% calculation of the 2D neutral surface.
rho2 = gsw_rho(SA,CT,2000);
average_rho2_value = [1036:0.1:1037.3];
number_of_surfaces = length(average_rho2_value);
%--------------------------------------------------------------------------


%--------------------------------------------------------------------------
% pre-assign memory
[zi,yi,xi] = size(SA);

SAns_initial = nan(length(neutral_surfaces),yi,xi);
CTns_initial = nan(length(neutral_surfaces),yi,xi);
pns_initial = nan(length(neutral_surfaces),yi,xi);

SAns_final = nan(length(neutral_surfaces),yi,xi);
CTns_final = nan(length(neutral_surfaces),yi,xi);
pns_final = nan(length(neutral_surfaces),yi,xi);
%--------------------------------------------------------------------------


%--------------------------------------------------------------------------
% initial condition
for I1 = 1:yi
    for I2 = 1:xi
        [Idata] = find(~isnan(squeeze(rho2(:,I1,I2))));
        if length(Idata) >= 2
            [SAns_initial(:,I1,I2),CTns_initial(:,I1,I2),pns_initial(:,I1,I2)] = gsw_linear_interp_SA_CT_p(squeeze(SA(Idata,I1,I2)),squeeze(CT(Idata,I1,I2)),squeeze(p(Idata,I1,I2)),squeeze(rho2(Idata,I1,I2)),average_rho2_value);
        end
    end
end
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% Set the settings. 
% If the data is global, ie extends over GMT, then settings.wrap = 'long';
% else settings.wrap = 'none';
settings.wrap = 'long';

% Do not change settings.grid 
settings.grid = 'bgrid';
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% calculate the scaling factor
[e2t,e1t] = gsw_ns2d_scaling_factor(lats,longs,settings);
%--------------------------------------------------------------------------


%--------------------------------------------------------------------------
% calculate the 2D neutral surfaces
for Isurface = 1:length(number_of_surfaces)
    
    [SAns_final(Isurface,:,:),CTns_final(Isurface,:,:),pns_final(Isurface,:,:)] = gsw_ns2d(SA,CT,p,squeeze(SAns_initial(Isurface,:,:)),squeeze(CTns_initial(Isurface,:,:)),squeeze(pns_initial(Isurface,:,:)),e1t,e2t,settings);
    
end
%--------------------------------------------------------------------------

