function neighbour = gsw_ns2d_neighbour(I2_limit,I1_limit,ng,Iocean,settings)

% select regions
% build neighbour matrix -> build a matrix which is like a look-up
% table to see which gridpoints communicate with each other
neighbour = nan(5,length(Iocean));

switch settings.wrap
    
    case 'none'
        for I = 1:length(Iocean)
            [I2,I1] = ind2sub([I2_limit,I1_limit],Iocean(I));
            
            if (I2 == 1) && (I1 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = nan;
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = nan;
            elseif (I2 == I2_limit) && (I1 == I1_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = nan;
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = nan;
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I2 == 1) && (I1 == I1_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = nan;
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = nan;
            elseif (I2 == I2_limit) && (I1 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = nan;
                neighbour(4,I) = nan;
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I2 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = nan;
            elseif (I1 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = nan;
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I2 == I2_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = nan;
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I1 == I1_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = nan;
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = ng(I2-1,I1);
            else
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = ng(I2-1,I1);
            end
        end
        
    case 'long'
        for I = 1:length(Iocean)
            [I2,I1] = ind2sub([I2_limit,I1_limit],Iocean(I));
            
            if (I2 == 1) && (I1 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1_limit);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = nan;
            elseif (I2 == I2_limit) && (I1 == I1_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = nan;
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I2 == 1) && (I1 == I1_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = nan;
            elseif (I2 == I2_limit) && (I1 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1_limit);
                neighbour(4,I) = nan;
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I2 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = nan;
            elseif (I1 == 1)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1_limit);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I2 == I2_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = nan;
                neighbour(5,I) = ng(I2-1,I1);
            elseif (I1 == I1_limit)
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = ng(I2-1,I1);
            else
                neighbour(1,I) = ng(I2,I1);
                neighbour(2,I) = ng(I2,I1+1);
                neighbour(3,I) = ng(I2,I1-1);
                neighbour(4,I) = ng(I2+1,I1);
                neighbour(5,I) = ng(I2-1,I1);
            end
        end
        
end


    
    
