function [SAns_i,CTns_i,pns_i] = gsw_ns2d_vertical_solve(SA,CT,p,SAns,CTns,pns,phi_prime)

[zi,yi,xi] = size(SA);

rho_SSO_0_0 = 1.028107021542752e+03;
phi_prime_dummy(1,:,:) = -rho_SSO_0_0.*phi_prime;

SAns_dummy(1,:,:) = SAns;
CTns_dummy(1,:,:) = CTns;
pns_dummy(1,:,:) = pns;

rho_error = (gsw_rho(SA,CT,repmat(pns_dummy,[zi,1,1])) ...
    - repmat(gsw_rho(SAns_dummy,CTns_dummy,pns_dummy),[zi,1,1])) ...
    - repmat((phi_prime_dummy.*gsw_rho(SAns_dummy,CTns_dummy,pns_dummy)),[zi,1,1]);

SAns_i = NaN(yi,xi);
CTns_i = SAns_i;
pns_i = SAns_i;

for I2 = 1:yi
    for I1 = 1:xi
        
        [Idata] = find(~isnan(rho_error(:,I2,I1)));
        
        if ~isempty(Idata)
            
            rho_error_cast = rho_error(Idata,I2,I1);
            SA_cast = SA(Idata,I2,I1);
            CT_cast = CT(Idata,I2,I1);
            p_cast = p(Idata,I2,I1);
            
            rho_error_flag = 0;
            rho_error_count = 0;
            
            while rho_error_flag == 0
                
                rho_error_count = rho_error_count + 1;
                
                if min(abs(rho_error_cast)) > 0.000001
                    
                    I_below = find(rho_error_cast > 0);
                    I_above = find(rho_error_cast < 0);
                    
                    if ~isempty(I_below) & ~isempty(I_above)
                        
                        [dummy Ibottle_above] = max(rho_error_cast(I_above));
                        [dummy Ibottle_below] = min(rho_error_cast(I_below));
                        
                        if rho_error_count > 100
                            Ibottle_below = Ibottle_above + 10;
                        end
                        
                        SA_dummy = [SA_cast(I_above(Ibottle_above)): (SA_cast(I_below(Ibottle_below))-SA_cast(I_above(Ibottle_above)))/100 : SA_cast(I_below(Ibottle_below))];
                        CT_dummy = [CT_cast(I_above(Ibottle_above)): (CT_cast(I_below(Ibottle_below))-CT_cast(I_above(Ibottle_above)))/100 : CT_cast(I_below(Ibottle_below))];
                        p_dummy = [p_cast(I_above(Ibottle_above)): (p_cast(I_below(Ibottle_below))-p_cast(I_above(Ibottle_above)))/100 : p_cast(I_below(Ibottle_below))];
                        
                        if isempty(SA_dummy) | isempty(CT_dummy) | isempty(p_dummy)
                            expand_rho_error_flag = 0;
                            try
                                while expand_rho_error_flag == 0
                                    
                                    Ibottle_below = Ibottle_below + 1;
                                    
                                    SA_dummy = [SA_cast(I_above(Ibottle_above)): (SA_cast(I_below(Ibottle_below))-SA_cast(I_above(Ibottle_above)))/100  :SA_cast(I_below(Ibottle_below))];
                                    CT_dummy = [CT_cast(I_above(Ibottle_above)): (CT_cast(I_below(Ibottle_below))-CT_cast(I_above(Ibottle_above)))/100 : CT_cast(I_below(Ibottle_below))];
                                    p_dummy = [p_cast(I_above(Ibottle_above)): (p_cast(I_below(Ibottle_below))-p_cast(I_above(Ibottle_above)))/100 : p_cast(I_below(Ibottle_below))];
                                    
                                    if ~isempty(SA_dummy) & ~isempty(CT_dummy) & ~isempty(p_dummy)
                                        expand_rho_error_flag = 1;
                                    end
                                    
                                end
                            catch
                                
                                pns_i(I2,I1) = NaN;
                                rho_error_flag = 1;
                                expand_rho_error_flag = 1;
                                
                            end
                        end
                        
                        if rho_error_flag ~= 1
                            ms1 = length(SA_dummy);
                            
                            rho_error_cast = (gsw_rho(SA_dummy(:),CT_dummy(:),repmat(pns_dummy(1,I2,I1),[ms1,1,1])) ...
                                - repmat(gsw_rho(SAns_dummy(1,I2,I1),CTns_dummy(1,I2,I1),pns_dummy(1,I2,I1)),[ms1,1,1])) ...
                                - repmat((phi_prime_dummy(1,I2,I1).*gsw_rho(SAns_dummy(1,I2,I1),CTns_dummy(1,I2,I1),pns_dummy(1,I2,I1))),[ms1,1,1]);
                            
                            SA_cast = SA_dummy;
                            CT_cast = CT_dummy;
                            p_cast = p_dummy;
                            
                        end
                        
                    else
                        pns_i(I2,I1) = NaN;
                        rho_error_flag = 1;
                    end
                    
                else
                    
                    [dummy,Iminr] = min(abs(rho_error_cast));
                    SAns_i(I2,I1) = SA_cast(Iminr);
                    CTns_i(I2,I1) = CT_cast(Iminr);                    
                    pns_i(I2,I1) = p_cast(Iminr);
                    
                    rho_error_flag = 1;
                end
            end
        end
    end
end
